#ifndef __GRADIENT_LED_H__
#define __GRADIENT_LED_H__

#define MAX_BRIGHT_VALUE	1000	//λ
#define LIGHT1_NUM			15		//һε
#define LIGHT2_NUM			6		//ڶε
#define LED1_LOW_BRIGHT		14		//һĬϵֵҪڸֵ
#define LED1_HIGH_BRIGHT	180		//һĬϸֵҪ255
#define LED2_LOW_BRIGHT		20		//ڶĬϵֵҪڸֵ
#define LED2_HIGH_BRIGHT	255		//ڶĬϸֵҪ255
#define ABOUT_SUBTR_LED		3		//ƶЧȥͷβ

//ƴ
typedef struct {
	unsigned char last_mode;		// ϴģʽ
    unsigned short value;			// /λ
	unsigned char direction;		// 1./ǰ0./ˣ
	unsigned int speed;				// ٶ
	unsigned int speed_count;		// ٶȼ
	unsigned short position;		// ƫλ
	unsigned short num;				// 
	unsigned short high_bright;		// 
	unsigned short low_bright;		// 
} LightData;

extern LightData Light1;
extern LightData Light2;

void Light_Init(void);

void Light1_gradient(unsigned short value);		//õƴ1(λ)
void Light1_about(unsigned short speed);		//õƴ1ƶ(ٶ)
void Light1_middle(unsigned short speed);		//õƴ1м(ٶ)
void Light1_All_On(unsigned short value);		//õƴ1ȫȫ()
void Light1_Highlights3(unsigned short value);	//õƴ1ģʽ3(λMAX_BRIGHT_VALUEİٷֱ)
void Light1_Highlights4(unsigned short value);	//õƴ1ģʽ3(λMAX_BRIGHT_VALUEİٷֱ)
void Light2_Highlights1(unsigned short value);	//õƴ2ģʽ1(λ)
void Light2_Highlights2(unsigned short value);	//õƴ2ģʽ2(λ)


void update_All_On_led(LightData* Light);			//ȫȫ
void update_Highlights4_led(LightData* Light);		//ģʽ4MAX_BRIGHT_VALUEİٷֱȣ
void update_Highlights3_led(LightData* Light);		//ģʽ3MAX_BRIGHT_VALUEİٷֱȣ
void update_Highlights2_led(LightData* Light);		//ģʽ2ֱӷҪĵ鵽value
void update_Highlights1_led(LightData* Light);		//ģʽ1ֱӷҪĵ鵽value
void update_gradient_led(LightData* Light);			//ģʽ
void update_about_dynamic_led(LightData* Light);	//ƶ
void update_middle_dynamic_led(LightData* Light);	//м



#endif
