#include "menu.h"
#include <stdio.h>
#include <stdlib.h>
#include "touch_instruct.h"
#include "touch.h"
#include "gradient_led.h"
#include "buzzer_and_led.h"
/*
׹ܲ˵
UPԴصַlankexi.cn
*/

#define MAX_FUNCTIONS 6

double value1, value2, value3, value4, value5, value6 = 500;

// 1λ
void function_1(TouchEvent* event) {
	static unsigned short count = 0;
	if(event->event_type == 3 & count < 5000) {
		if(event->event_type < 0){
			value1 = value1 + event->swipe_speed;
		}else {
			value1 = value1 - event->swipe_speed;
		}
	}
	if(event->event_type == 5) {
		value1 = value1 + (double)(event->swipe_distance) / 20000;
		count ++;
	} else {
		count = 0;
	}
	if(value1 > 1000){value1 = 1000;}
	else if(value1 < 0){value1 = 0;}
	Light1_gradient(value1);
}
// 2ݵλòͬٶƶλ
void function_2(TouchEvent* event) {
	if(event->event_type != 0 || event->press_down){
		value2 = value2 + ((double)touch_slider_value-500)/7000;
	}
	if(value2 > 1000){value2 = 1000;}
	else if(value2 < 0){value2 = 0;}
	Light1_Highlights3(value2);
}
// 3ǰѹλ
void function_3(TouchEvent* event) {
	if(event->event_type != 0 || event->press_down){
		value3 =touch_slider_value;
	}
	Light1_gradient(value3);
}
// 4ѡģʽѡ䶯ٶȺͷмȷϣ
void function_4(TouchEvent* event) {
	static unsigned int count, direction, speed = 200;
	count ++;
	if (count > speed){
		if(direction == 1){
			value4 ++;
			if (value4 >= 1001){value4 = 0;}
		} 
		else if(direction == 0){
			value4 --;
			if (value4 <= 0){value4 = 1000;}
		}
		count = 0;
	}
	if(event->event_type != 0 || event->press_down){
		speed = (350 - (abs(touch_slider_value-500) - 150)) * 2;
		if(speed < 50){speed = 15;}
		if (touch_slider_value < 350) {
			direction = 0;
		}
		else if (touch_slider_value > 650) {
			direction = 1;
		}
		else {
			direction = 2;
		}
	}
	
	Light1_Highlights3(value4);
}
// 5ʾѹȣذҲǻ˳ģ
void function_5(TouchEvent* event) {
	Light1_gradient(touch_size/2);
}
// 6
void function_6(TouchEvent* event) {
	static unsigned short count = 0;
	if(event->event_type == 3 & count < 5000) {
		if(event->event_type < 0){
			value6 = value6 + event->swipe_speed;
		}else {
			value6 = value6 - event->swipe_speed;
		}
	}
	if(event->event_type == 5) {
		value6 = value6 + (double)(event->swipe_distance) / 20000;
		count ++;
	} else {
		count = 0;
	}
	if(value6 > 1000){value6 = 1000;}
	else if(value6 < 200){value6 = 200;}
	
	float brightness = value6 / 1000.0;
	if(brightness < 0.2){brightness = 0.2;}
	if(brightness > 1){brightness = 1;}
	
	//õƴ
	Light1.high_bright = LED1_HIGH_BRIGHT * brightness;	// 
	Light1.low_bright =	LED1_LOW_BRIGHT * brightness;	// 
	
	Light2.high_bright = LED2_HIGH_BRIGHT * brightness;	// 
	Light2.low_bright =	LED2_LOW_BRIGHT * brightness;	// 
	Light1_gradient(value6);
	
	//رշ
	if (event->event_type == 4){Buzzer_EN = !Buzzer_EN;}
}

// ܺ
void (*functions[MAX_FUNCTIONS])(TouchEvent* event) = { function_1, function_2, function_3, function_4, function_5, function_6 };

// ʼ˵ϵͳ
void init_menu(MenuSystem *menu) {
    menu->current_function = 0;
    menu->mode = MENU_MODE;
}

// ˵лܣѹ빦
void handle_menu_mode(MenuSystem *menu, TouchEvent *event) {
    // ⻬лѡеĹ
    if (event->event_type == 3) {  // ǻ¼
        if (event->swipe_direction == 1) {
            menu->current_function = (menu->current_function + 1) % MAX_FUNCTIONS;  // һлһ
        } else if (event->swipe_direction == -1) {
            menu->current_function = (menu->current_function == 0) ? (MAX_FUNCTIONS - 1) : (menu->current_function - 1);  // 󻬶
        }
		Light2_Highlights1(menu->current_function);	// ָʾ״̬
    }

    // ѹѡеĹ
    if (event->event_type == 2) {  // ѹ¼
        menu->mode = FUNCTION_MODE;
		Light2_Highlights2(menu->current_function);	// ָʾ״̬
        functions[menu->current_function](event);  // ִеǰѡеĹ
		//handle_function_mode(menu, event);  // ģʽ
    }
}

// ģʽ
void handle_function_mode(MenuSystem *menu, TouchEvent *event) {
    while (1) {
        functions[menu->current_function](event);  // ִеǰѡеĹ
		
        // ѹ˳
        if (detect_touch_event(event) && event->event_type == 2) {
            menu->mode = MENU_MODE;  // л˵ģʽ
			Light2_Highlights1(menu->current_function);	// ָʾ״̬
            break;  // ˳ѭ
        }
    }
}
