#include "touch_instruct.h"
#include "touch.h"
#include <stdlib.h>
#include "buzzer_and_led.h"
/*
ʶָ
UPԴصַlankexi.cn
*/
#define TOUCH_CLICK_THRESHOLD		20000						// ֵʱ䣩
#define TOUCH_SLIDE_THRESHOLD		SLIDER_VALUE_MAX / 10		// ֵλã
#define TOUCH_ONE_TIME				22000						// λֵʱ䣩
#define TOUCH_FORCE_THRESHOLD		1600						// ѹֵС
#define TOUCH_LONG_PRESS			80000						// ֵʱ䣩

#define TOUCH_NULL_VALUE			99999//Ҫ

unsigned int last_position = TOUCH_NULL_VALUE;		// һελ
unsigned int first_position = TOUCH_NULL_VALUE;		// һελ
unsigned int last_event_type = 0;					// һβ¼
unsigned int start_position = TOUCH_NULL_VALUE;		// ʼλ
unsigned int swipe_start_counter = 0;				// ʼ
unsigned int loop_counter = 0;						// Ӧ
unsigned int delay_counter = 0;						// ӳӦ
unsigned int last_delay_counter = 0;				// һӳӦ״̬

//ⴥ¼ѹλס
int detect_touch_event(TouchEvent* event) {
	// ʼ¼
	touch_event_Init(event);
	if (TOUCH_slider()) {
		event->press_down = 1;
		if(first_position == TOUCH_NULL_VALUE){first_position = touch_slider_value;}
		// ѹ
		if (touch_size > TOUCH_FORCE_THRESHOLD) {
			if(last_event_type != 2){
				event->event_type = 2;  // ѹ¼
				last_event_type = 2;
				select_sound_group(2);
			}
			else{//ѹִ
				reset_touch_state();
			}
			delay_counter = 5;
		}
		
		// 
		if (last_position != TOUCH_NULL_VALUE && start_position == TOUCH_NULL_VALUE && abs(touch_slider_value - first_position) > TOUCH_SLIDE_THRESHOLD){
			start_position = touch_slider_value;	//λ
			swipe_start_counter = loop_counter;		//ʱ
		}
	
		// ס
		if (start_position != TOUCH_NULL_VALUE && last_event_type != 2) {
			event->swipe_distance = touch_slider_value - first_position;
			event->event_type = 5;  // ס¼
			last_event_type = 5;
		}
		
		// 
		else if (loop_counter > TOUCH_LONG_PRESS && last_event_type == 0) {
			event->event_type = 4;  // ¼
			last_event_type = 4;
			select_sound_group(4);
		}

		// Ӽλ
		loop_counter ++;
		last_position = touch_slider_value;
    } 
	else {
		// λ 
		if (last_event_type == 5 && loop_counter - swipe_start_counter < TOUCH_ONE_TIME && start_position != TOUCH_NULL_VALUE) {
			int delta_pos = first_position - touch_slider_value;
			int delta_loop = loop_counter - swipe_start_counter;
			event->swipe_speed = delta_loop / delta_pos *50;
			event->swipe_direction = (delta_pos > 0) ? -1 : 1;  // 1ʾң-1ʾ
			event->event_type = 3;  // ¼
			last_event_type = 3;
			delay_counter = 5;
			if(event->swipe_direction == 1){select_sound_group(3);}
			else{select_sound_group(5);}
		}
		// ¼
		else if (last_event_type == 0 && last_position != TOUCH_NULL_VALUE && loop_counter < TOUCH_CLICK_THRESHOLD) {
			event->event_type = 1;  // ¼
			delay_counter = 2;
			select_sound_group(1);
		}
		event->press_down = 0;
		// ¼
		last_event_type = 0;  
		// ״̬
		reset_touch_state();
	}
	// ִеǰӳӦ
	if(delay_counter != 0 && last_delay_counter == 0){
		last_delay_counter = delay_counter;
	}
	else if(delay_counter != 0){
		event->event_type = 0;
		delay_counter --;
	}
	else{
		last_delay_counter = 0;
	}
	
	return (event->event_type != 0);  // Ƿ¼
}

// ʼ¼
void touch_event_Init(TouchEvent* event){
	event->swipe_direction = 0;
	event->swipe_distance = 0;
	event->event_type = 0;
}

//ô״̬
void reset_touch_state(void){
	first_position = TOUCH_NULL_VALUE;
	loop_counter = 0;
	last_position = TOUCH_NULL_VALUE;
	start_position = TOUCH_NULL_VALUE;
	swipe_start_counter = 0;
}
