#include "stm32f10x.h"
#include <math.h>
#include "main.h"
#include "gradient_led.h"
#include "ws2812.h"
/*
ʵһWS2811ɫƴ˫
UPԴصַlankexi.cn
*/

LightData Light1;
LightData Light2;

//õƴ
void Light_Init(void){
	Light1.position = 0;					// ƫλ
	Light1.num = LIGHT1_NUM;				// 
	Light1.high_bright = LED1_HIGH_BRIGHT*0.6;	// 
	Light1.low_bright =	LED1_LOW_BRIGHT*0.6;	// 
	
	Light2.position = LIGHT1_NUM;			// ƫλ
	Light2.num = LIGHT2_NUM;				// 
	Light2.high_bright = LED2_HIGH_BRIGHT*0.6;	// 
	Light2.low_bright =	LED2_LOW_BRIGHT*0.6;	// 
}


//õƴ1
void Light1_gradient(unsigned short value){
	//ÿʼ״̬
	if(Light1.last_mode != 1){
		Light1.direction = 1;			// 1./ǰ0./ˣ
		Light1.speed = 0;				// ٶ
		Light1.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light1.value = value;
	if (Light1.value > MAX_BRIGHT_VALUE){Light1.value = MAX_BRIGHT_VALUE;}
	update_gradient_led(&Light1);
}

//õƴ1ƶ
void Light1_about(unsigned short speed){
	//ÿʼ״̬
	if(Light1.last_mode != 2){
		Light1.value = 0;				// /λ
		Light1.direction = 1;			// 1./ǰ0./ˣ
		Light1.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light1.speed = speed;
	update_about_dynamic_led(&Light1);
}

//õƴ1м
void Light1_middle(unsigned short speed){
	//ÿʼ״̬
	if(Light1.last_mode != 3){
		Light1.value = Light1.high_bright/4;	// /λ
		Light1.direction = 1;			// 1./ǰ0./ˣ
		Light1.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light1.speed = speed;
	update_middle_dynamic_led(&Light1);
}

//õƴ1ȫȫ
void Light1_All_On(unsigned short value){
	//ÿʼ״̬
	if(Light1.last_mode != 4){
		Light1.direction = 1;			// 1./ǰ0./ˣ
		Light1.speed = 0;				// ٶ
		Light1.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light1.value = value;
	if (Light1.value > 255){Light1.value = 255;}
	update_All_On_led(&Light1);
}

//õƴ2ģʽ1
void Light2_Highlights1(unsigned short value){
	//ÿʼ״̬
	if(Light2.last_mode != 5){
		Light2.direction = 1;			// 1./ǰ0./ˣ
		Light2.speed = 0;				// ٶ
		Light2.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light2.value = value;
	update_Highlights1_led(&Light2);
}

//õƴ2ģʽ2
void Light2_Highlights2(unsigned short value){
	//ÿʼ״̬
	if(Light2.last_mode != 6){
		Light2.direction = 1;			// 1./ǰ0./ˣ
		Light2.speed = 0;				// ٶ
		Light2.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light2.value = value;
	update_Highlights2_led(&Light2);
}

//õƴ1ģʽ3
void Light1_Highlights3(unsigned short value){
	//ÿʼ״̬
	if(Light1.last_mode != 7){
		Light1.direction = 1;			// 1./ǰ0./ˣ
		Light1.speed = 0;				// ٶ
		Light1.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light1.value = value;
	if (Light1.value > MAX_BRIGHT_VALUE){Light1.value = MAX_BRIGHT_VALUE;}
	update_Highlights3_led(&Light1);
}

//õƴ1ģʽ4
void Light1_Highlights4(unsigned short value){
	//ÿʼ״̬
	if(Light1.last_mode != 8){
		Light1.direction = 1;			// 1./ǰ0./ˣ
		Light1.speed = 0;				// ٶ
		Light1.speed_count = 0;			// ٶȼ
	}
	//ˢ״̬
	Light1.value = value;
	if (Light1.value > MAX_BRIGHT_VALUE){Light1.value = MAX_BRIGHT_VALUE;}
	update_Highlights4_led(&Light1);
}

//ȫȫ
void update_All_On_led(LightData* Light)
{
	unsigned short i = 0;
	while(i < Light->num)
	{
		WS2812_Data[Light->position + i] = Light->value;
		i++;
	}
	Light->last_mode = 4;
}

//ģʽ1
void update_Highlights1_led(LightData* Light)
{
	unsigned short i = 0;
	while(i < Light->num)
	{
		if(i == Light->value){WS2812_Data[Light->position + i] = Light->high_bright;}
		else{WS2812_Data[Light->position + i] = Light->low_bright;}
		i++;
	}
	Light->last_mode = 5;
}

//ģʽ2
void update_Highlights2_led(LightData* Light)
{
	unsigned short i = 0;
	while(i < Light->num)
	{
		if(i == Light->value){WS2812_Data[Light->position + i] = Light->high_bright;}
		else{WS2812_Data[Light->position + i] = 0;}
		i++;
	}
	Light->last_mode = 6;
}

//ģʽ3
void update_Highlights3_led(LightData* Light)
{
	unsigned int LED_Proportion_value = MAX_BRIGHT_VALUE / (Light->num - 1);		// LEDӦıֵ
	unsigned int low_bright_num = Light->value / LED_Proportion_value;				// ĵ
	unsigned int Middle_bright_value1 = (Light->value % LED_Proportion_value) * (Light->high_bright - Light->low_bright) / (LED_Proportion_value) + Light->low_bright;	//ɵֵ
	if (low_bright_num >= Light->num){low_bright_num = Light->num -1;}
	unsigned int Middle_bright_value0 = Light->high_bright - Middle_bright_value1 + Light->low_bright;
	for(int i=0; i<Light->num; i++)
	{
		WS2812_Data[i + Light->position] = Light->low_bright;
	}
	WS2812_Data[low_bright_num + Light->position] = Middle_bright_value0;
	if(low_bright_num < Light->num-1){
		WS2812_Data[low_bright_num + Light->position+1] = Middle_bright_value1;
	}
	Light->last_mode = 7;
}
//ģʽ4
void update_Highlights4_led(LightData* Light)
{
	unsigned int LED_Proportion_value = MAX_BRIGHT_VALUE / (Light->num - 1);		// LEDӦıֵ
	unsigned int low_bright_num = Light->value / LED_Proportion_value;				// ĵ
	unsigned int Middle_bright_value1 = (Light->value % LED_Proportion_value) * (Light->high_bright - Light->low_bright) / (LED_Proportion_value) + Light->low_bright;	//ɵֵ
	if (low_bright_num >= Light->num){low_bright_num = Light->num -1;}
	unsigned int Middle_bright_value0 = Light->high_bright - Middle_bright_value1 + Light->low_bright;
	for(int i=0; i<Light->num; i++)
	{
		WS2812_Data[i + Light->position] = 0;
	}
	WS2812_Data[low_bright_num + Light->position] = Middle_bright_value0;
	if(low_bright_num < Light->num-1){
		WS2812_Data[low_bright_num + Light->position+1] = Middle_bright_value1;
	}
	Light->last_mode = 8;
}

//
void update_gradient_led(LightData* Light)
{
	int i;
	unsigned int LED_Proportion_value = MAX_BRIGHT_VALUE / Light->num;					// LEDӦıֵ
	unsigned int High_bright_num = Light->value / LED_Proportion_value;					// ȫ
	unsigned int Middle_bright_value = (Light->value % LED_Proportion_value) * (Light->high_bright - Light->low_bright) / (LED_Proportion_value) + Light->low_bright;	//ɵֵ
	if (High_bright_num >= Light->num){High_bright_num = Light->num -1;}
	for(i=0; i<High_bright_num; i++)
	{
		WS2812_Data[i + Light->position] = Light->high_bright;
	}
	WS2812_Data[i + Light->position] = Middle_bright_value;
	i ++;
	while(i < Light->num)
	{
		WS2812_Data[i + Light->position] = Light->low_bright;
		i++;
	}
	Light->last_mode = 1;
}

// ƶ
void update_about_dynamic_led(LightData* Light)
{
	Light->speed_count ++;
	
	if(Light->speed_count > Light->speed)
	{
		if(Light->value < 255*(ABOUT_SUBTR_LED+1)){Light->value = 255*(ABOUT_SUBTR_LED+1);}
		if(Light->direction == 0)
		{
			Light->value ++;
			if(Light->value >= ((Light->num-ABOUT_SUBTR_LED) * 255))
			{
				Light->direction = 1;
			}
		}
		else
		{
			Light->value --;
			if(Light->value <= 256*(ABOUT_SUBTR_LED+1))
			{
				Light->direction = 0;
			}
		}
		Light->speed_count = 0;
	}
	for(int i=0; i<Light->num; i++)
	{
		if(i == (Light->value / 255))
		{
			WS2812_Data[i + Light->position] = (Light->value % 255) * Light->high_bright / 255;
			WS2812_Data[i + Light->position - 1] = (255 - Light->value % 255) * Light->high_bright / 255;
			i ++;
		}
		else{WS2812_Data[i + Light->position] = 0;}
	}
	Light->last_mode = 2;
}

//м
void update_middle_dynamic_led(LightData* Light)
{
	Light->speed_count ++;
	
	if(Light->speed_count > Light->speed)
	{
		if(Light->direction == 0)
		{
			Light->value ++;
			if(Light->value >= Light->high_bright/2)
			{
				Light->direction = 1;
			}
		}
		else
		{
			Light->value --;
			if(Light->value <= Light->low_bright/2)
			{
				Light->direction = 0;
			}
		}
		Light->speed_count = 0;
	}
	if(Light->value > 255){Light->value = 255;}
	for(int i=0; i<Light->num; i++)
	{
		if(i == (Light->num / 2)){WS2812_Data[i + Light->position] = Light->value;}
		else{WS2812_Data[i + Light->position] = 0;}
	}
	Light->last_mode = 3;
}
