#include "stm32f10x.h"
#include "main.h"
#include "touch.h"
#include "ws2812.h"
#include "gradient_led.h"
#include "touch_instruct.h"
#include "menu.h"
#include "buzzer_and_led.h"

/*׹ܲ˵๦ܴ
 ⴥѹλס
׹ܲ˵ҪʵһЩֱӷŵܲ˵Ｔ

ĬϽ˵
˵	1.һлѡй
			2.ѹѡй
			
ܲ	1λ
			2ݵλòͬٶƶλ
			3ǰѹλ
			4ѡģʽѡ䶯ٶȺͷмȷϣ
			5ʾѹȣذҲǻ˳ģ
			6ȡرշ
			йѹ˳ǰܻص˵
			
ʾ/ʾ	1.ݴָĲͬͬʾ
			2.LED(ԱߵһȦ)дѹʾͬЧ
			3.ƴ1ʾǰģʽֵҪȥʵܵú͵ƴһֵȥʵּ
			4.ƴ2ʾǰѡлʹõĹ
UPԴصַlankexi.cn
*/

TouchEvent touch_event;

int main(void)
{
	SetSysClockTo64();		//ʱ
	TOUCH_Init();			//ô
	WS2812_Init();			//WS2812
	Light_Init();			//õƴ
	Buzzer_And_Led_Init();	//÷LED
	
	// ʼ˵
	MenuSystem menu;
    init_menu(&menu);

	while (1)
	{
		if(touch_vref_confirm != 0)				//⻷
		{
			Light1_about(16);
		}
		// ˵/
		else if (detect_touch_event(&touch_event)) {
			if (menu.mode == MENU_MODE) {
				handle_menu_mode(&menu, &touch_event);  // ˵
			} 
			if (menu.mode == FUNCTION_MODE) {
				handle_function_mode(&menu, &touch_event);  // ģʽ
			}
		}
		else {
			Light1_middle(1500);						// ָʾ״̬
			Light2_Highlights1(menu.current_function);	// ָʾ״̬
		}
	}
}

void SetSysClockTo64(void)
{
    // 1.  HSI
    RCC_HSICmd(ENABLE);

    // 2. ȴ HSI 
    while (RCC_GetFlagStatus(RCC_FLAG_HSIRDY) == RESET);

    // 3.  FLASH Ԥȡ͵ȴ״̬
    FLASH->ACR |= FLASH_ACR_PRFTBE;  // Ԥȡ
    FLASH->ACR &= ~FLASH_ACR_LATENCY;
    FLASH->ACR |= FLASH_ACR_LATENCY_2;  // 2ȴ״̬

    // 4.  AHB, APB1  APB2 Ƶ
    RCC_HCLKConfig(RCC_SYSCLK_Div1); // AHB ʱ (HCLK) = SYSCLK
    RCC_PCLK1Config(RCC_HCLK_Div2); // APB1 ʱ (PCLK1) = HCLK / 2
    RCC_PCLK2Config(RCC_HCLK_Div1); // APB2 ʱ (PCLK2) = HCLK

    // 5.  PLL
    RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_16); // PLL ʱԴѡ HSI/2, ƵϵΪ 16

    // 6.  PLL
    RCC_PLLCmd(ENABLE);

    // 7. ȴ PLL 
    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);

    // 8. ѡ PLL ΪϵͳʱԴ
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    // 9. ȴ PLL ϵͳʱԴ
    while (RCC_GetSYSCLKSource() != 0x08);
}

//ʱus
void delay_us(unsigned int delayus)
{
	unsigned int i, j;
	for(i=0;i<delayus;i++)
	{
		for(j=0;j<8;j++);//Լ1us
	}
}
//ʱms
void delay_ms(unsigned int delayms)
{
	unsigned int i, j;
	for(i=0;i<delayms;i++)
	{
		for(j=0;j<8300;j++);//Լ1ms
	}
}
