#include "stm32f10x.h"
#include "main.h"
#include "ws2812.h"
#include "gradient_led.h"

/*
WS2811ɫ
ţGPIOPB3
UPԴصַlankexi.cn
*/
unsigned char WS2812_Data[WS2812_LED_NUM];			//WS2812ݻ
unsigned char WS2812_Set_cache = 1;					//ǰڲĻ
unsigned char WS2812_Bit_Data[WS2812_LED_NUM*8];	//WS2812ݣλ
unsigned char WS2812_Set_Data = 0;					//
WS2812_State WS2812_Send_State = WS2812_IDLE;		//״̬
DMA_InitTypeDef WS2812_DMA_InitStructure;			//DMAṹ


//WS2812
void WS2812_Init(void)
{
	WS2812_GPIO_Configuration();	//GPIO
	TIM2_Configuration();			//öʱ
	LED_DMA_Configuration();		//DMA
}

//ˢʾ
void WS2812_Send_Data(void)
{
	unsigned int i, j;
	for(i=0; i<WS2812_LED_NUM; i++)		//λ
	{
		for(j=0; j<8; j++)
		{
			if((WS2812_Data[i] << j) & 0x80){WS2812_Bit_Data[i*8+j] = WS2812_BIT_DATA1;}
			else{WS2812_Bit_Data[i*8+j] = WS2812_BIT_DATA0;}
		}
	}
	WS2812_Send_Data_Bit();				//λ
	WS2812_Send_State = WS2812_SEND;	//״̬Ϊ
}

//λ
void WS2812_Send_Data_Bit(void)
{
	// رնʱ 2
	TIM_Cmd(TIM2, DISABLE);
	// ر DMA1 ͨ1
	DMA_Cmd(DMA1_Channel7, DISABLE);
    WS2812_DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)&WS2812_Bit_Data;	//ݵַ
    WS2812_DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;		//ڴַ
	DMA_Init(DMA1_Channel7, &WS2812_DMA_InitStructure);
	//  DMA1 ͨ1
	DMA_SetCurrDataCounter(DMA1_Channel7, WS2812_LED_NUM*8);
	DMA_Cmd(DMA1_Channel7, ENABLE);
	// öʱ 2
	TIM_Cmd(TIM2, ENABLE);
}

//
void WS2812_Send_Set(void)
{
	// رնʱ 2
	TIM_Cmd(TIM2, DISABLE);
	// ر DMA1 ͨ1
	DMA_Cmd(DMA1_Channel7, DISABLE);
	WS2812_DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)&WS2812_Set_Data;	//ݵַ
    WS2812_DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Disable;		//ڴַ
	DMA_Init(DMA1_Channel7, &WS2812_DMA_InitStructure);
	//  DMA1 ͨ1
	DMA_SetCurrDataCounter(DMA1_Channel7, 400);
	DMA_Cmd(DMA1_Channel7, ENABLE);
	// öʱ 2
	TIM_Cmd(TIM2, ENABLE);
	WS2812_Send_State = WS2812_SET;		//״̬Ϊ
}

//GPIO
void WS2812_GPIO_Configuration(void)
{
	//GPIOBʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
	// JTAG
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);
	//GPIO
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB,&GPIO_InitStructure);
}

//öʱ
void TIM2_Configuration(void) {
	// ʹܶʱ3ʱ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
	// ʹ AFIO ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
    //  TIM2_CH3 Ϊӳģʽ
    GPIO_PinRemapConfig(GPIO_FullRemap_TIM2, ENABLE);
	
    TIM_TimeBaseInitTypeDef PWM_TIM_TimeBaseStructure;
    // öʱ2
    PWM_TIM_TimeBaseStructure.TIM_Period = WS2812_BIT_DATA0 + WS2812_BIT_DATA1 - 1; //ʱʱ
    PWM_TIM_TimeBaseStructure.TIM_Prescaler = 0; 				//ԤƵ
    PWM_TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;		//Ƶ
	//PWM_TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;			//ظ
    PWM_TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;	//ϼ
    // ʼʱ2
    TIM_TimeBaseInit(TIM2, &PWM_TIM_TimeBaseStructure);
	
	//Ƚϳʼ
	TIM_OCInitTypeDef TIM_OCInitStructure;

	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;				//ȽģʽѡPWMģʽ1
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;		//ԣѡΪ
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//ʹTIM2_CH1
	TIM_OCInitStructure.TIM_Pulse = 2;								//ʼCCRֵ
	TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Reset;
	TIM_OC2Init(TIM2, &TIM_OCInitStructure);						//TIM2Ƚͨ3
	TIM_OC2PreloadConfig(TIM2, TIM_OCPreload_Enable);				//Ԥװ

	// ʹ TIM2 DMA  CC2
    TIM_DMACmd(TIM2, TIM_DMA_CC2, ENABLE);
	
	// öʱ 2
	TIM_Cmd(TIM2, ENABLE);
}

//DMA
void LED_DMA_Configuration(void) {
    // ʹ DMA1 ʱ
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

    DMA_DeInit(DMA1_Channel7);
	
    // ʼ DMA ṹ
    WS2812_DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&(TIM2->CCR2); // PWM /ȽϼĴĵַ
    WS2812_DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)&WS2812_Bit_Data;
    WS2812_DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST; 			// ݴ䷽򣺴ڴ浽
    WS2812_DMA_InitStructure.DMA_BufferSize = WS2812_LED_NUM*8; 		// Ҫ
    WS2812_DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    WS2812_DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    WS2812_DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord; // PWM  16 λݴС
    WS2812_DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte; 	//  8 λݴС
    WS2812_DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; 			// DMA ģʽͨѭ
    WS2812_DMA_InitStructure.DMA_Priority = DMA_Priority_High; 	// DMA ȼ
    WS2812_DMA_InitStructure.DMA_M2M = DMA_M2M_Disable; 			// 洢洢ģʽֹ
    DMA_Init(DMA1_Channel7, &WS2812_DMA_InitStructure);
	
	DMA_ITConfig(DMA1_Channel7, DMA_IT_TC, ENABLE);
	
	NVIC_InitTypeDef NVIC_InitStructure;
	NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel7_IRQn; 	// DMA1 ͨ1 жͨ
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;	// ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0; 			// ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			 // ʹжͨ
	NVIC_Init(&NVIC_InitStructure);
	//  DMA1 ͨ1
	DMA_SetCurrDataCounter(DMA1_Channel7, WS2812_LED_NUM*8);
	DMA_Cmd(DMA1_Channel7, ENABLE);
}

// DMA1 ͨ1 жϴ
void DMA1_Channel7_IRQHandler(void)
{
    // 鴫жϱ־λ
    if (DMA_GetITStatus(DMA1_IT_TC7))
    {
		// жϱ־λ
        DMA_ClearITPendingBit(DMA1_IT_TC7);
		if (WS2812_Send_State == WS2812_SEND)	//Ƿ״̬
		{
			WS2812_Send_Set();					//
		}
		else if (WS2812_Send_State == WS2812_SET)	//״̬
		{
			WS2812_Send_State = WS2812_IDLE;	//ˢ״̬Ϊ
		}
    }
}

